# Room View Plugin

This unofficial TaleSpire plugin automatically hides/reveals hide volumes (e.g. rooms) based on mini location(s).
Support multiple minis with ability for minis to split up and minis (e.g. foes) that don't hide/reveal.

Video Link: https://youtu.be/Q08y9fv01G0

This plugin, like all others, is free but if you want to donate, use: http://LordAshes.ca/TalespireDonate/Donate.php

## Change Log

```
3.1.0: Added option to prevent rooms from re-hiding if empty.
3.1.0: Bug fix to actually use the ``Reveal Update Frequency When Moving`` configuration.
3.0.0: Total rewrite of the code to make it stand alone. Only requires Asset Data and File Access Plugins.
2.0.1: Improvement to expose default reveler name configuration, when not present, on start-up 
2.0.0: Fix for BR HF Integration update
1.0.0: Initial release
```

## Install

Use R2ModMan or similar installer to install this plugin.

### Initial Rooms Setup

This needs to be done once per board. It does NOT need to be repeated each time the board is loaded.

1. Start Talespire
2. Create hide volumes for each area (e.g. room)

See tips below for making compatible rooms

### Initial Character Setup

Each mini can be designated as being a revealer or not. When reavealer minis move from room to room,
they cause the new room to be revealed and the old room to be hidden (unless another revealer is in
the old room). To change this setting:

1. Right click a mini to open the radial menu
2. Select the Reveal / No Reveal entry to toggle it

The default state is not to reveal so that adding enemy creatures will cause them not to reveal rooms.

## Room View Usage

Move revealing minis from revealed area to an unrevealed area and the hide volumes will automatically be hidden
and revealed based on the location of all revealing minis.

Moving minis that are not revealing minis has no effect on the hide volumes.

The Hide Volumes can still be revealed and hidden manually but as soon as the mini moves, the hide volumes will
resync based on the revealing minis locations.

## Configurations

``Rehide Empty Rooms``: If true, empty rooms\* will rehide. If false, empty rooms\* remain revealed.
``Reveal Update Frequency When Moving``: Time, in second, at which rooms update occur when moving a revealer mini.
``Log Diagnostics``: Determines if additional information is written to the logs.

\*Note: In this context, empty rooms refers to rooms which do not have a revealer mini inside them.

## Creating Areas (Rooms) Compatible With Room View Plugin

Any tile that is in any Hide Volume that is hidden will not be shown. As such the following tips are recommended
when making areas for the Room View plugin:

1. Use double walls. By using double walls, no matter which room is shown, the wall will be there. If only a single
   wall, between rooms, is used then it can only be included as part of one hide volume and thus will appear as a
   hole when that hide volume is hidden.
   
2. Use double door. For the same reason as above, if a double door is used, one of the two doors will be visible no
    matter which of the adjoining rooms is visible. This does mean opening two doors when a door is opened but if
	only a single door is used, one of the two adjoining rooms will have a hole when visisble.
	
3. If using elevation, try to keep the elevation the same at the boundary points of hide volumes or do not include
   the floor as part of the hide volume. The plugin can compensate for small elevation changes when moving the
   mini by mouse (as opposed to keyboard) but if the elevation change is large, the mini will likely end up in the
   floor.
   
4. If you want an effect such a being able to always see the outside walls of a building (so it can be seen when
   standing outside the building) but not reveal any of the interior rooms, create the outer wall so that it is not
   in the hide volumes. This way such walls will always be visible regardless of the location of the minis.
